
#include "math.h"

#include "config.h"
#include "reduce_server.h"

static int convert(int v)
{
  int i;

  /* Arbitrary time-consuming calculation: */
  for (i = 0; i < 1000; i++) {
    v = ((v * v) + v) % 10;
  }

  return v;
}

static int deconvert(int v)
{
  return convert(v);
}


tally_t init()
{
  return 0;
}

tally_t accum(tally_t tally, int i, data_t *myArray)
{
  myArray[i] = convert(myArray[i]); /* overwriting input is kind of a cheat */
  return tally + myArray[i];
}

tally_t combine(tally_t tally1, tally_t tally2)
{
  return tally1 + tally2;
}

tally_t scanGen(tally_t tally, int i, 
                data_t *myArray, result_t *myResult)
{
  tally += myArray[i];
  myResult[i] = deconvert(tally);
  return tally;
}
